﻿Imports System.IO

Module Module1

    Private ReadOnly conjugations1 = {" ARE ", " AM ", " WERE ", " WAS ", " YOU ", " I ", " YOUR ", " MY ", " IVE ", " YOUVE ", " IM ", " ME ", " US ", " WE ", "."}
    Private ReadOnly conjugations2 = {" AM+ ", " ARE+ ", " WAS+ ", " WERE+ ", " I+ ", " YOU+ ", " MY+ ", " YOUR+ ", " YOUVE+ ", " IVE+ ", " YOURE+ ", " YOU+ ", " YOU+ ", " YOU+ ", "."}

    Sub Main()
        '===========================================================================
        ' Subject: ELIZA DOCTOR                       Date: 06-13-89 (00:00)       
        '  Author: Frederick B. Maxwell, Jr.          Code: QB, QBasic, GWBasic    
        '  Origin: ELIZA,DOCTOR                     Packet: AI.ABC
        '===========================================================================
        ' This is a TWO Part Snippet,  ELIZA.BAS & ELIZA.DAT

        ' Eliza/Doctor
        ' Original author: Joseph Weizenbaum
        ' This version: Frederick B. Maxwell, Jr.
        ' Version 1.0    2/12/85        Initial CP/M (MBASIC) release.
        ' Version 2.0    6/13/89        Initial PC (GWBASIC) release.
        '
        '***********************************************************************
        '
        '     This version of Eliza is released into the public domain.
        '
        '***********************************************************************
        '
        Dim REPLIES$(300)    ' up to 300 responses.
        Dim KWD$(200)   ' up to 200 keywords.
        Dim FIRST(200)  ' first reply for keyword number in subscript.
        Dim LAST(200)   ' last reply   "     "      "     "     "    .
        Dim OFFSET(200) ' offset from first reply for each keyword.
        Dim PREVIOUS$ = ""
        Dim REMAINS$ = ""
        '
        '***********************************************************************
        '
        '     -Initialization-
        '     We will read in data from the file ELIZA.DAT in the following format:
        '          KEYWORD 1
        '          KEYWORD N all keywords which will get the same responses
        '          !         indicates end of keywords
        '          RESPONSE 1     all responses for this/these keywords.
        '          RESPONSE N
        '          .         indicates end of responses
        '
        '***********************************************************************
        '
        Dim fsr1 As New StreamReader("ELIZA.DAT")        ' file with keyword/response data.
        Dim MAXKEY As Integer = 0                ' number of keywords
        Dim MINREPLY As Integer = 1              ' first reply for first keyword.
        Dim MAXREPLY As Integer = 0
        '
        While Not fsr1.EndOfStream
            Dim NUMKEYS As Integer = 0               ' number of keys with same responses.
400:        Dim F$ = fsr1.ReadLine         ' get keyword or !
            If F$ = "!" Then GoTo 480 :             ' if ! then get replys.
            MAXKEY += 1       ' we've got one more keyword
            Console.Write(".")           ' let user know we're still alive.
            NUMKEYS += 1          ' 1 more keyword with same replys.
            KWD$(MAXKEY) = " " + F$ + " "  ' put in a keyword bounded with spaces.
            GoTo 400
            '
480:        F$ = fsr1.ReadLine         ' get the reply or .
            If F$ = "." Then GoTo 540 :             ' check for end of reply list.
            MAXREPLY += 1   ' 1 more reply.
            REPLIES$(MAXREPLY) = F$
            GoTo 480
            '
540:        For KWD2 = MAXKEY - NUMKEYS + 1 To MAXKEY
                FIRST(KWD2) = MINREPLY          ' first reply for key.
                LAST(KWD2) = MAXREPLY      ' last reply for key.
            Next KWD2
            MINREPLY = MAXREPLY + 1        ' set up for next keyword.
            '
        End While
        fsr1.Close()
        '
        '***********************************************************************
        '
        '     Here we go!  Send intro message to "patient".
        '
        '***********************************************************************
        '
        Console.WriteLine()
        Console.WriteLine("HI!  I'M ELIZA.  LET'S TALK.  TYPE `BYE' TO END THIS SESSION.")
        '
        '***********************************************************************
730: '
        '     Get the user input into I$.
        '
        '***********************************************************************
        '
780:    Console.Write(">") : Dim I$ = Console.ReadLine          ' Get user input.
        If I$ = "" Then GoTo 780 :         ' Just hitting return isn't good enough.
        I$ = " " + I$ + " " ' Put a space on each end.
        '
        '***********************************************************************
        '
        '     Get rid of punctuation/extraneous characters, and make uppercase.
        '
        '***********************************************************************
        '
        Dim L As Integer = 1           ' Start at the first character
890:    Dim C$ = Mid(I$, L, 1)  ' Get the character.
        '
        '     Capitalize if necessary.
        '
        If C$ >= "a" And C$ <= "z" Then MID$(I$, L, 1) = Chr(Asc(C$) - &H20) : GoTo 890
        '
        If C$ = " " Then GoTo 990 :         ' Spaces are OK.
        If C$ >= "0" And C$ <= "9" Then GoTo 990 :         ' So are numbers.
        If C$ >= "A" And C$ <= "Z" Then GoTo 990 :         ' So are capital letters.
        I$ = Left(I$, L - 1) + Mid(I$, L + 1) : GoTo 890 ' Delete character.
990:    L += 1                 ' Next character.
        If L <= Len(I$) Then GoTo 890 :         ' Keep on processin'
        '
        '***********************************************************************
        '
        '    Has he/she said this before?  Does he/she want to terminate session?
        '
        '***********************************************************************
        '
        If I$ = PREVIOUS$ Then Console.WriteLine("PLEASE DON'T REPEAT YOURSELF!") : GoTo 730
        PREVIOUS$ = I$                        ' Set up for next run.
        '
        If I$ = " BYE " Then Console.WriteLine("TALK TO YOU LATER!  BYE!") : End
        '
        '***********************************************************************
        '
        '    Find keyword in user input string (I$).
        '
        '***********************************************************************
        '
        Dim K2 As Integer
        For K = 1 To MAXKEY - 1  ' Start search at keyword number 1.
            C = InStr(I$, KWD$(K))        ' Look for the keyword in the string.
            K2 = K
            If C <> 0 Then GoTo 1230 :             ' Exit on match.
        Next K
        K2 += 1
1230:   Dim KWD3 As Integer = K2                  ' Keyword number.
        If KWD3 = MAXKEY Then GoTo 1280 :         ' We don't need anything if no match.
        REMAINS$ = Mid(I$, C - 1 + Len(KWD$(KWD3))) ' Grab remainder for reply.
        '
        '***********************************************************************
1280: '
        '    Take everything after the keyword (remains$) and conjugate it
        '         using the data for conjugation.
        '
        '***********************************************************************
        '
        Dim index = 0
1350:   Dim S$ = conjugations1(index), R$ = conjugations2(index)                   ' Read search and replacement words.
        index += 1
        If S$ = "." Then GoTo 1430 :         ' Periods (.) idicate end of data.
        C = InStr(REMAINS$, S$)       ' Search for string S$ in REMAINS$
        If C = 0 Then GoTo 1350 :         ' If no match, try the next one.
        Dim TEMP$ = Left(REMAINS$, C - 1) ' Replacement.
        TEMP$ += R$             ' Word.
        REMAINS$ = TEMP$ + Mid(REMAINS$, C + Len(S$)) ' Right side.
        GoTo 1350                ' Next conjugation to be done.
1430:   C = InStr(REMAINS$, "+")      ' Strip the plus signs out.
        If C = 0 Then GoTo 1470
        REMAINS$ = Left(REMAINS$, C - 1) + Mid(REMAINS$, C + 1)  ' Strip it.
        GoTo 1430                ' Go for the next one.
1470: '
        ' Handle the special case of " I " being the last word.
        '
        If Right(REMAINS$, 3) <> " I " Then GoTo 1540
        REMAINS$ = Left(REMAINS$, Len(REMAINS$) - 2) + "ME "
        '
        '***********************************************************************
1540: '
        '    Get the reply using the keyword number (KWD).
        '
        '***********************************************************************
        '
        Dim REPLY$ = REPLIES$(FIRST(KWD3) + OFFSET(KWD3))            ' Get reply.
        OFFSET(KWD3) = OFFSET(KWD3) + 1      ' Point to next reply.
        If OFFSET(KWD3) + FIRST(KWD3) > LAST(KWD3) Then OFFSET(KWD3) = 0 :         ' Wrap.
        '
        '    Bump offsets on all keywords that use these replys.
        '
        For TEMP2 = 1 To MAXKEY
            If FIRST(TEMP2) = FIRST(KWD3) Then OFFSET(TEMP2) = OFFSET(KWD3)
        Next TEMP2
        '
        '    If the last character of the reply is *, append REMAINS$ to reply.
        '
        If Right(REPLY$, 1) = "*" Then REPLY$ = Left(REPLY$, Len(REPLY$) - 1) + REMAINS$
        Console.WriteLine(REPLY$)
        GoTo 730
        '
        '***********************************************************************
        '
        '    Data for conjugations in the following form:
        '         Word to replace , Replacement with + appended on end
        '    + is to keep the word from being switched back later and will
        '    be stripped before output.
        '
        '***********************************************************************
        '
        '
    End Sub

End Module
